#pragma semicolon 1

#include <sourcemod>
#include <shop>
#include <vip>

#define ITEM_NAME "credit_multiplier"
new g_Percent[MAXPLAYERS + 1]; // получает кредитов на x% больше (0 = нет прав)

public Plugin:myinfo = 
{
	name	= "VIP [Credit Multiplier]",
	author	= "wS",
	version = "1.0.1"
};

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_SELECT))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	
	LoadTranslations("vip_credit_multiplier.phrases");
}

public Action:Shop_OnCreditsGiven(client, &credits, by_who)
{
	if (by_who == CREDITS_BY_NATIVE && g_Percent[client])
	{
		credits += RoundToFloor(float(credits * g_Percent[client]) / 100.0);
		return Plugin_Changed;
	}
	return Plugin_Continue;
}

public OnClientDisconnect_Post(client)
{
	g_Percent[client] = 0;
}

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_Percent[client])
	{
		IntToString(g_Percent[client], ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	return UpdateAccess(client, ItemValue);
}

stock VipGiveAction:UpdateAccess(client, String:ItemValue[ITEM_INFO_LENGTH])
{
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;
										
	new value = StringToInt(ItemValue);
	if (value < 1)
		return VGA_BadValue;
	
	if (value == g_Percent[client])
		return VGA_SameValue;
	
	g_Percent[client] = value;
	
	IntToString(value, ItemValue, ITEM_INFO_LENGTH);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, true, ItemValue, 16);

	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	g_Percent[client] = 0;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, false);
}

public VIP_MenuSelect(client, ItemID)
{
	new Handle:panel = CreatePanel();
	
	decl String:sText[256];
	FormatEx(sText, sizeof(sText), "%T\n \n", "vcm_info", client, g_Percent[client]);
	DrawPanelText(panel, sText);
	
	SetPanelCurrentKey(panel, 8);
	DrawPanelItem(panel, "<-");
	
	SetPanelCurrentKey(panel, GetEngineVersion() == Engine_CSGO ? 9 : 10);
	FormatEx(sText, sizeof(sText), "%T", "vcm_exit", client);
	DrawPanelItem(panel, sText);
	
	SendPanelToClient(panel, client, panel_CallBack, 0);
	CloseHandle(panel);
}

public panel_CallBack(Handle:panel, MenuAction:action, client, item)
{
	if (action == MenuAction_Select && item == 8)
	{
		PLAY_EXIT_BACK_SOUND(client);
		VIP_ShowMenu(client);
	}
}